#ifndef MISC_H
#define MISC_H
#include<iostream>
#include<iomanip>
#include<fstream>
#include<cstdio>
#include<cstdlib>
#include<cstring>
#include<cassert>
#include<cmath>
#include<string>
#include<stdint.h>
#include<map>
#include<vector>
#include<sstream>
#include<time.h>

//#include "dpClass.h"
//#include "dpcellClass.h"


using namespace std ;

double logStar_nits(size_t);
double logStar_bits(size_t);
double nits2bits(double);
double bits2nits(double);
void printSeq2Term(const string, string="");
void printMatrixToTerm(const vector<vector<double> >,int=1,int=5, string="",int=20, int=20);
vector<vector<double> > matrixAdd( vector<vector<double> >, vector<vector<double> >);
vector<vector<double> > matrixMultiply( vector<vector<double> >, vector<vector<double> >);
vector<vector<double> > matrixMultiply(vector<vector<double> >,int);
void printFSAstr2Algn(const string&, const string&, const string&);
vector<string> fsastr2Algn(const string&, const string&, const string&);
string algn2Fsastr(const vector<string>&);
string reverse(string&);
double wtCodeLen_bits(int);
double wtCodeLen_nits(int);
void printToTerminalMsgStatus(string);
void printToTerminalMsgStatus_wo_newline(string);
string getTerminalColorString(string,size_t);
#endif
